package de.fraunhofer.iem.dataprovider.kpi.strategy

import de.fraunhofer.iem.dataprovider.kpi.dto.KPIHierarchyEdgeDto

class RatioKPICalculationStrategy : KPICalculationStrategy {
    @Suppress("MagicNumber")
    override fun calculateKPI(children: List<KPIHierarchyEdgeDto>): Pair<Int, List<KPIHierarchyEdgeDto>> {
        if (children.size != 2) {
            throw Exception("Requires exactly two children")
        }
        val firstValue = children[0].to.getValue()
        val secondValue = children[1].to.getValue()
        if (firstValue >= secondValue) {
            return Pair(((secondValue.toDouble() / firstValue.toDouble()) * 100).toInt(), children)
        }
        return Pair(((firstValue.toDouble() / secondValue.toDouble()) * 100).toInt(), children)
    }
}
